/*
 * Sun RPC is a product of Sun Microsystems, Inc. and is provided for
 * unrestricted use provided that this legend is included on all tape
 * media and as a part of the software program in whole or part.  Users
 * may copy or modify Sun RPC without charge, but are not authorized
 * to license or distribute it to anyone else except as part of a product or
 * program developed by the user.
 * 
 * SUN RPC IS PROVIDED AS IS WITH NO WARRANTIES OF ANY KIND INCLUDING THE
 * WARRANTIES OF DESIGN, MERCHANTIBILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE, OR ARISING FROM A COURSE OF DEALING, USAGE OR TRADE PRACTICE.
 * 
 * Sun RPC is provided with no support and without any obligation on the
 * part of Sun Microsystems, Inc. to assist in its use, correction,
 * modification or enhancement.
 * 
 * SUN MICROSYSTEMS, INC. SHALL HAVE NO LIABILITY WITH RESPECT TO THE
 * INFRINGEMENT OF COPYRIGHTS, TRADE SECRETS OR ANY PATENTS BY SUN RPC
 * OR ANY PART THEREOF.
 * 
 * In no event will Sun Microsystems, Inc. be liable for any lost revenue
 * or profits or other special, indirect and consequential damages, even if
 * Sun has been advised of the possibility of such damages.
 * 
 * Sun Microsystems, Inc.
 * 2550 Garcia Avenue
 * Mountain View, California  94043
 */

#if !defined(lint) && defined(SCCSIDS)
static char sccsid[] = "@(#)clnt_tli_lib.c  1.3  92/06/22  Copyr 1988 Sun Micro";
#endif

#include <stdio.h>
#include <rpc/rpc.h>
#include "test.h"
#include <netinet/in.h>
#include <sys/socket.h>
#include <poll.h>

#define	RPC_RQST_SZ 28		/* size of an RPC header with AUTH_NULL */

#define NUM_FDS 1
char buf[33000];
int *datalen = (int *)buf;
extern int fd;
extern char transport[];
char resbuf[1024];
static  int TIMEOUT = 25000;
struct sockaddr_in sin;
extern struct netconfig *nconf;

static int *
check_select_dg()
{
	static int res;
	struct pollfd pollfds[NUM_FDS];
	int ln;
	
	pollfds[0].fd = fd; 
	pollfds[0].events = POLLIN;
	
	switch (poll(pollfds, NUM_FDS, TIMEOUT)) {
	case -1:
		perror("poll");
		return (NULL);
	case 0:
		printf("timedout\n");
		return (NULL);
	default:
		break;
	};

	if (pollfds[0].revents == POLLIN) {
		if (tli_recvfrom(fd, resbuf, 1024, 0, NULL, &ln) < 0) {
			perror("could not read datagram");
			return (NULL);
		};
		memcpy(&res, resbuf, sizeof (int));
#ifdef DEBUG
		printf("Ans %d\n", res);
#endif
	}
	return (&res);
}

static int *
null_call_1_dg(argp, clnt)
	int *argp;
	CLIENT *clnt;
{

	memcpy(buf, argp, sizeof (int));

	if (tli_sendto(fd, buf, RPC_RQST_SZ + (2 * sizeof (int)),
	    0, (struct sockaddr_in *)&sin, sizeof (sin)) < 0) {
		perror("error in sending datagram");
		return (NULL);
	}
	return (check_select_dg());
}

static void *
thru_i_reset_1_dg(argp, clnt)
	caddr_t *argp;
	CLIENT *clnt;
{
	if (tli_sendto(fd, buf, RPC_RQST_SZ + sizeof (int),
	    0, (struct sockaddr_in *)&sin, sizeof (sin)) < 0) {
		perror("error in sending datagram");
		return (NULL);
	}
	return (check_select_dg());
}

static int *
thru_o_1400_1_dg(argp, clnt)
	opaqueArg1400 *argp;
	CLIENT *clnt;
{
	if (tli_sendto(fd, buf, RPC_RQST_SZ + 1400 + sizeof (int), 0,
		(struct sockaddr_in *)&sin, sizeof (sin)) < 0) {
		perror("error in sending datagram");
		return (NULL);
	}
	return (check_select_dg());
}

static int *
thru_o_var_1_dg(argp, clnt)
	opaqueArgVar *argp;
	CLIENT *clnt;
{
#ifdef DEBUG
	printf("Sending out %d bytes\n",
			RPC_RQST_SZ + argp->data.data_len + 4);
#endif
	if (tli_sendto(fd, buf, RPC_RQST_SZ + argp->data.data_len + 4 +
		sizeof (int), 0, (struct sockaddr_in *)&sin,
		sizeof (sin)) < 0) {
		perror("error in sending datagram");
		return (NULL);
	}
	return (check_select_dg());
}

int *
thru_ui_var_1(argp, clnt)
	UintArgVar *argp;
	CLIENT *clnt;
{
#ifdef DEBUG
	printf("Sending out %d bytes\n",
		RPC_RQST_SZ + ((argp->UintArgVar_len + 1) * 4));
#endif
	if (tli_sendto(fd, buf, RPC_RQST_SZ + ((argp->UintArgVar_len + 1) * 4) +
		sizeof (int), 0, (struct sockaddr_in *)&sin,
		sizeof (sin)) < 0) {
		perror("error in sending datagram");
		return (NULL);
	}
	return (check_select_dg());
}


int *
thru_xu_var_1(argp, clnt)
	UtestArgVar *argp;
	CLIENT *clnt;
{
#ifdef DEBUG
	printf("Sending out %d bytes\n",
		RPC_RQST_SZ + ((argp->UtestArgVar_len + 1) * 4));
#endif
	if (tli_sendto(fd, buf, RPC_RQST_SZ + ((argp->UtestArgVar_len + 1) *
		4) + sizeof (int), 0, (struct sockaddr_in *)&sin,
		sizeof (sin)) < 0) {
		perror("error in sending datagram");
		return (NULL);
	}
	return (check_select_dg());
}

static int *
thru_xt_var_1_dg(argp, clnt)
	TtestArgVar *argp;
	CLIENT *clnt;
{
#ifdef DEBUG
	printf("Sending out %d bytes\n",
		RPC_RQST_SZ + ((argp->TtestArgVar_len + 1) * 4));
#endif

	if (tli_sendto(fd, buf, RPC_RQST_SZ + ((argp->TtestArgVar_len + 1) * 4) +
		sizeof (int), 0, (struct sockaddr_in *)&sin,
		sizeof (sin)) < 0) {
		perror("error in sending datagram");
		return (NULL);
	}
	return (check_select_dg());
}

static int *
check_select_vc()
{
	static int res;
	struct pollfd pollfds[NUM_FDS];
	
	pollfds[0].fd = fd; 
	pollfds[0].events = POLLIN;
	
	switch (poll(pollfds, NUM_FDS, TIMEOUT)) {
	case -1:
		perror("poll");
		return (NULL);
	case 0:
		printf("timedout\n");
		return (NULL);
	default:
		break;
	};

	if (pollfds[0].revents == POLLIN) {
		int flag;

		if (t_rcv(fd, resbuf, 1024, &flag) < 0) {
			perror("could not read data");
			return (NULL);
		}
		memcpy(&res, resbuf, sizeof (int));
#ifdef DEBUG
		printf("Ans %d\n", res);
#endif
	}
	return (&res);

}

static int *
null_call_1_vc(argp, clnt)
	int *argp;
	CLIENT *clnt;
{
	int i;

	*datalen = htonl(RPC_RQST_SZ) +  sizeof (int);
	*(datalen+1) = *argp;
	i = tli_write(fd, buf, RPC_RQST_SZ + (2 * sizeof (int)));
	if (i < 0) {
		perror("error in tli_write TCP call");
		return (NULL);
	}
	return (check_select_vc());
}

static void *
thru_i_reset_1_vc(argp, clnt)
	caddr_t *argp;
	CLIENT *clnt;
{
	*datalen = htonl(RPC_RQST_SZ);
	if (tli_write(fd, buf, RPC_RQST_SZ + sizeof (int)) < 0) {
		perror("error in tli_write TCP call");
		return (NULL);
	}
	return (check_select_vc());
}

static int *
thru_o_1400_1_vc(argp, clnt)
	opaqueArg1400 *argp;
	CLIENT *clnt;
{
	*datalen = htonl(RPC_RQST_SZ + 1400);
	if (tli_write(fd, buf, RPC_RQST_SZ + 1400 + sizeof (int)) < 0) {
		perror("error in tli_write TCP call");
		return (NULL);
	}
	return (check_select_vc());
}

static int *
thru_o_var_1_vc(argp, clnt)
	opaqueArgVar *argp;
	CLIENT *clnt;
{
	*datalen = htonl(RPC_RQST_SZ + argp->data.data_len + 4);
	if (tli_write(fd, buf, RPC_RQST_SZ + argp->data.data_len + 4 +
		sizeof (int)) < 0) {
		perror("error in tli_write TCP call");
		return (NULL);
	}
	return (check_select_vc());
}

int *
thru_ti_var_1(argp, clnt)
	TintArgVar *argp;
	CLIENT *clnt;
{
	*datalen = htonl(RPC_RQST_SZ + ((argp->TintArgVar_len + 1) * 4));
	if (tli_write(fd, buf, RPC_RQST_SZ + 1400 +
		((argp->TintArgVar_len + 1) * 4) + sizeof (int)) < 0) {
		perror("error in tli_write TCP call");
		return (NULL);
	}
	return (check_select_vc());
}

int *
thru_xt_var_1(argp, clnt)
	TtestArgVar *argp;
	CLIENT *clnt;
{
	*datalen = htonl(RPC_RQST_SZ + ((argp->TtestArgVar_len + 1) * 4));
	if (tli_write(fd, buf, RPC_RQST_SZ + 1400 +
		((argp->TtestArgVar_len + 1) * 4) + sizeof (int)) < 0) {
		perror("error in tli_write TCP call");
		return (NULL);
	}
	return (check_select_vc());
}

int *
null_call_1(argp, clnt)
	int *argp;
	CLIENT *clnt;
{
	return ((nconf->nc_semantics == NC_TPI_CLTS) ?
		null_call_1_dg(argp, clnt) :
		null_call_1_vc(argp, clnt));
}

void *
thru_i_reset_1(argp, clnt)
	void *argp;
	CLIENT *clnt;
{
	return ((nconf->nc_semantics == NC_TPI_CLTS) ?
		thru_i_reset_1_dg(argp, clnt) :
		thru_i_reset_1_vc(argp, clnt));
}

int *
thru_o_1400_1(argp, clnt)
	opaqueArg1400 *argp;
	CLIENT *clnt;
{
	return ((nconf->nc_semantics == NC_TPI_CLTS) ?
		thru_o_1400_1_dg(argp, clnt) :
		thru_o_1400_1_vc(argp, clnt));
}

int *
thru_o_var_1(argp, clnt)
	opaqueArgVar *argp;
	CLIENT *clnt;
{
	return ((nconf->nc_semantics == NC_TPI_CLTS) ?
		thru_o_var_1_dg(argp, clnt) :
		thru_o_var_1_vc(argp, clnt));
}


tli_sendto(fd, buf, len, flags, to, tolen)
	int fd;
	char *buf;
	int len;
	int flags;
	struct sockaddr *to;
	int tolen;
{
	struct t_unitdata tu_data;
	extern struct netbuf *svcaddr;
	
	tu_data.addr = *svcaddr;
	tu_data.udata.buf = buf;
	tu_data.udata.len = len;
	tu_data.opt.len = 0;
	if (t_sndudata(fd, &tu_data) == -1) 
		return (-1);
	return (0);
}


/*
 * Socket calls emulated using TLI primitives
*/

tli_recvfrom(fd, buf, len, flags, from, fromlen)
	int fd;
	char *buf;
	int len, flags;

	struct sockaddr *from;
	int *fromlen;
{
	struct t_unitdata tr_data;
	int moreflag;

	tr_data.opt.maxlen = 0;
	tr_data.udata.maxlen = len;
	tr_data.udata.buf = buf;
	if (t_rcvudata(fd, &tr_data, &moreflag) != 0)
		return (0);


	return (tr_data.udata.len);
}

tli_write(fd, buf, len)
	int fd;
	char *buf;
	int len;
{
	int flag;

	return (t_snd(fd, buf, len, &flag));
}

